<?php
$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"] ?: array()) + array("_128dbe01c1bad9f48615c68be" . "c445794" => base64_decode("cHVibGlzaC5lZGl0X2NhdC52Y" . "WxpZF9uYW1l"), "_f1e6d6ccdd8b8b79d2406bc0c00e8" . "ba8" => base64_decode("Li4vY29tbW9uL2" . "1ldGFkYXRhX3Br" . "Zy5waHA="), "_d155d43a39de93f858123c6b6ce31d" . "8a" => base64_decode("cHJlZ19tY" . "XRjaA=="), "_0c5123aa744f69bbc0e8b3ea2f6e84" . "7d" => base64_decode("bG1" . "zZw" . "=="), "_f61ce5d1f564e87e3f720c" . "376acc6718" => base64_decode("cHVibGlzaC5hZGRfY2F0Lm" . "VudGVyX25hbWU="), "_a591754a8ddcdbda9c80" . "f1db4d911e14" => base64_decode("aXNfbn" . "VsbA=="), "_4d707fa" . "b93bebb0" . "0bbe69e8" . "159697c9" . "0" => base64_decode(""), "_c5100d62369ce6c930c7c274c3ad1b" . "31" => base64_decode("Li4vY29tbW9uL3B1Ymxpc2hfZnVuY3R" . "pb25zLnBocA=="), "_c06c961" . "f393742e" . "cfd52b72" . "263ac947" . "0" => base64_decode("aW50dmF" . "s"), "_ef1b393a04a102d659860236a" . "7ee04ab" => base64_decode("cHVibGlzaC51bmFibGVfd" . "G9fc2F2ZV9tZXRhZGF0YQ" . "=="), "_5e9a99dc0dd49b907abf1b35" . "e96965f8" => base64_decode("dH" . "Jp" . "bQ" . "=="), "_c118dec84d7f" . "f3999fcc614bd" . "da08110" => base64_decode("L15bYS16QS1aMC05XC1cX1w" . "uXSskLw=="));
require_once $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_f1e6d6ccdd8b8b79" . "d2406bc0c00e8ba8"];
require_once $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_c5100d62369ce6c930c7c274c3ad" . "1b31"];






class PublishObject extends ErrorHandler
{
    protected $id = 0;
    protected $title = '';
    protected $creator = 0;
    protected $description = '';
    protected $perm_id;
    
    
    
    
    
    
    public $metadata;
    
    
    
    
    
    
    protected $perms;
    
    
    
    
    protected $save_perms, $perms_loaded;
    
    
    
    
    protected $pub_location = null;
    protected $acl_loaded;
    
    
    
    
    protected $acl;
    
    
    
    
    
    
    public function __construct($aggregation)
    {
        $this->metadata = new MetaDataSimple($aggregation);
        $this->perms = new UnifiedPermissions();
        $this->acl = new Claromentis\Core\Acl\Acl(PERM_CLASS_UNIFIED);
        $this->perms_loaded = false;
        $this->save_perms = false;
        $this->perm_id = 0;
        $this->pub_location = null;
    }
    
    
    
    
    
    public function __destruct()
    {
        unset($this->perms);
        unset($this->metadata);
        unset($this->pub_location);
    }
    public function __clone()
    {
        $this->metadata = clone $this->metadata;
        
        
        
    }
    
    
    
    
    
    
    
    public function LoadPerms()
    {
        if ($this->perms->Load($this->perm_id)) {
            $this->perms_loaded = true;
            return true;
        } else {
            $this->perms_loaded = false;
            return false;
        }
    }
    
    
    
    
    
    
    
    public function LoadAcl()
    {
        global $g_application;
        $_3436ad73cf80729d5a2e43d861c31e8b = $g_application->acl;
        $this->acl->SetObjectId($this->perm_id);
        try {
            $_3436ad73cf80729d5a2e43d861c31e8b->Load($this->acl);
        } catch (\Claromentis\Core\Acl\Exception\AclException $e) {
            $this->acl_loaded = false;
            return false;
        }
        $this->acl_loaded = true;
        return true;
    }
    
    
    
    
    
    
    public function SaveMetadata()
    {
        if (!$this->id) {
            return $this->SetErrMsg($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_0c5123aa744f69bbc0e8b3ea2f6e8" . "47d"]($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_ef1b393a04a102d659860236a" . "7ee04ab"]));
        }
        $this->metadata->Save($this->id);
        return true;
    }
    
    
    
    
    
    
    
    public function SetValue($name, $value)
    {
        $this->metadata->SetValue($name, $value);
    }
    
    
    
    
    
    
    
    
    
    public function GetValue($name)
    {
        return $this->metadata->GetValue($name);
    }
    
    
    
    
    
    
    
    public function DeleteValue($name)
    {
        $this->metadata->DeleteValue($name);
    }
    
    
    
    
    
    
    
    
    
    public function SetPerms($_5f53bb9a0317b2cff1248a5d6f951ce0, $_d518e3269f1db8e80d2ccd12b33ff3d0 = false)
    {
        if ($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_a591754a8ddcdbda9c80f1db" . "4d911e14"]($_5f53bb9a0317b2cff1248a5d6f951ce0)) {
            $this->perm_id = 0;
            
            
            $this->perms->id = 0;
        } else {
            $this->perms = $_5f53bb9a0317b2cff1248a5d6f951ce0;
            $this->perm_id = $_5f53bb9a0317b2cff1248a5d6f951ce0->id;
            $this->save_perms = $_d518e3269f1db8e80d2ccd12b33ff3d0;
            $this->perms_loaded = true;
        }
        return true;
    }
    
    
    
    
    
    
    
    public function UserHasPermission($perms)
    {
        if (AuthUser::I()->IsReadonly() && $perms != PERM_VIEW) {
            return false;
        }
        
        
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->GetAcl()->Permits(AuthUser::I()->GetContext(), $perms, $this->creator);
        return $_1f24efd4735b7a11b391147435e7d35d;
    }
    
    
    
    
    
    
    public function GetPerms()
    {
        if (!$this->perms_loaded) {
            $this->LoadPerms();
        }
        return $this->perms;
    }
    
    
    
    
    
    
    public function GetAcl()
    {
        if (!$this->acl_loaded) {
            $this->LoadAcl();
        }
        return $this->acl;
    }
    
    
    
    
    
    
    
    public function GetId()
    {
        return $this->id;
    }
    public function GetCreator()
    {
        return $this->creator;
    }
    public function SetCreator($_022eeb17ad2461a772886fe0f5575520)
    {
        $this->creator = $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_c06c961f39" . "3742ecfd52b" . "72263ac9470"]($_022eeb17ad2461a772886fe0f5575520);
        return true;
    }
    public function GetTitle()
    {
        return $this->title;
    }
    public function SetTitle($title)
    {
        $this->title = $title;
        if ($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_5e9a99dc0dd49b907abf1b35e9696" . "5f8"]($title) == $GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_4d707fab93bebb00bb" . "e69e8159697c90"]) {
            return $this->SetErrMsg($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_0c5123aa744f69bbc0e8b3ea2f6e8" . "47d"]($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_f61ce5d1f564e87e3f720c37" . "6acc6718"]));
        }
        if (!$this->IsValidTitle($title)) {
            return $this->SetErrMsg($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_0c5123aa744f69bbc0e8b" . "3ea2f6e847d"]($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_128dbe01c1bad9f48615c68bec4" . "45794"]));
        }
        return true;
    }
    protected function IsValidTitle($title)
    {
        if (!$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_d155d43a3" . "9de93f8581" . "23c6b6ce31" . "d8a"]($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_c118dec84d7" . "ff3999fcc614" . "bdda08110"], $title)) {
            return false;
        }
        return true;
    }
    public function GetDescription()
    {
        return $this->description;
    }
    public function SetDescription($_28fd57f750dbb5ffb3ffad3a888358a9)
    {
        $this->description = $_28fd57f750dbb5ffb3ffad3a888358a9;
        return true;
    }
    public function GetPermId()
    {
        return $this->perm_id;
    }
    public function _SetPermId($_bb1041b59872d5ae0f6b35aca6c14513)
    {
        $this->perm_id = $_bb1041b59872d5ae0f6b35aca6c14513;
    }
}